From 44c0cd2b0ce07ea4b381e47b37495dd9db628c1f Mon Sep 17 00:00:00 2001
From: Harald Hoyer <harald@redhat.com>
Date: Mon, 14 Nov 2016 16:21:06 +0100
Subject: [PATCH] testsuite: add "-cpu host" to kvm call

---
 test/TEST-01-BASIC/test.sh        | 4 ++--
 test/TEST-02-SYSTEMD/test.sh      | 4 ++--
 test/TEST-03-USR-MOUNT/test.sh    | 4 ++--
 test/TEST-04-FULL-SYSTEMD/test.sh | 4 ++--
 test/TEST-10-RAID/test.sh         | 4 ++--
 test/TEST-11-LVM/test.sh          | 4 ++--
 test/TEST-12-RAID-DEG/test.sh     | 4 ++--
 test/TEST-13-ENC-RAID-LVM/test.sh | 8 ++++----
 test/TEST-14-IMSM/test.sh         | 2 +-
 test/TEST-15-BTRFSRAID/test.sh    | 4 ++--
 test/TEST-16-DMSQUASH/test.sh     | 4 ++--
 test/TEST-17-LVM-THIN/test.sh     | 4 ++--
 test/TEST-20-NFS/test.sh          | 4 ++--
 test/TEST-30-ISCSI/test.sh        | 6 +++---
 test/TEST-40-NBD/test.sh          | 6 +++---
 test/TEST-50-MULTINIC/test.sh     | 4 ++--
 16 files changed, 35 insertions(+), 35 deletions(-)

diff --git a/test/TEST-01-BASIC/test.sh b/test/TEST-01-BASIC/test.sh
index e74c6735..fe0989d8 100755
--- a/test/TEST-01-BASIC/test.sh
+++ b/test/TEST-01-BASIC/test.sh
@@ -11,7 +11,7 @@ test_run() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext3 \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/result \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
 	-watchdog i6300esb -watchdog-action poweroff \
         -no-reboot \
@@ -80,7 +80,7 @@ test_setup() {
 
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext3 \
-	-m 256M -smp 2 -nographic -net none \
+	-m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/dracut/root rw rootfstype=ext3 quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/root.ext3 || return 1
diff --git a/test/TEST-02-SYSTEMD/test.sh b/test/TEST-02-SYSTEMD/test.sh
index 97362787..03985099 100755
--- a/test/TEST-02-SYSTEMD/test.sh
+++ b/test/TEST-02-SYSTEMD/test.sh
@@ -8,7 +8,7 @@ KVERSION="${KVERSION-$(uname -r)}"
 test_run() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext3 \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=LABEL=dracut rw loglevel=77 systemd.log_level=debug systemd.log_target=console rd.retry=3 rd.info console=ttyS0,115200n81 selinux=0 rd.debug init=/sbin/init rd.shell=0 $DEBUGFAIL" \
@@ -77,7 +77,7 @@ test_setup() {
 
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext3 \
-	-m 256M -smp 2 -nographic -net none \
+	-m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/fakeroot rw rootfstype=ext3 quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/root.ext3 || return 1
diff --git a/test/TEST-03-USR-MOUNT/test.sh b/test/TEST-03-USR-MOUNT/test.sh
index c515613d..68fe443e 100755
--- a/test/TEST-03-USR-MOUNT/test.sh
+++ b/test/TEST-03-USR-MOUNT/test.sh
@@ -18,7 +18,7 @@ client_run() {
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.btrfs \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/usr.btrfs \
 	-drive format=raw,index=2,media=disk,file=$TESTDIR/result \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
 	-watchdog i6300esb -watchdog-action poweroff \
         -no-reboot \
@@ -115,7 +115,7 @@ test_setup() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.btrfs \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/usr.btrfs \
-	-m 256M -smp 2 -nographic -net none \
+	-m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/dracut/root rw rootfstype=btrfs quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/root.btrfs || return 1
diff --git a/test/TEST-04-FULL-SYSTEMD/test.sh b/test/TEST-04-FULL-SYSTEMD/test.sh
index 3baabb45..6ec43273 100755
--- a/test/TEST-04-FULL-SYSTEMD/test.sh
+++ b/test/TEST-04-FULL-SYSTEMD/test.sh
@@ -20,7 +20,7 @@ client_run() {
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.btrfs \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/usr.btrfs \
 	-drive format=raw,index=2,media=disk,file=$TESTDIR/result \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=LABEL=dracut $client_opts rd.retry=3 console=ttyS0,115200n81 selinux=0 $DEBUGOUT rd.shell=0 $DEBUGFAIL" \
@@ -252,7 +252,7 @@ EOF
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.btrfs \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/usr.btrfs \
-	-m 256M -smp 2 -nographic -net none \
+	-m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/fakeroot rw rootfstype=btrfs quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/root.btrfs || return 1
diff --git a/test/TEST-10-RAID/test.sh b/test/TEST-10-RAID/test.sh
index 5324457d..0338d18c 100755
--- a/test/TEST-10-RAID/test.sh
+++ b/test/TEST-10-RAID/test.sh
@@ -10,7 +10,7 @@ test_run() {
     DISKIMAGE=$TESTDIR/TEST-10-RAID-root.img
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$DISKIMAGE \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=/dev/dracut/root rd.auto rw rd.retry=10 console=ttyS0,115200n81 selinux=0 rd.shell=0 $DEBUGFAIL" \
@@ -77,7 +77,7 @@ test_setup() {
     # Invoke KVM and/or QEMU to actually create the target filesystem.
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$DISKIMAGE \
-	-m 256M -smp 2 -nographic -net none \
+	-m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/cannotreach rw rootfstype=ext2 console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $DISKIMAGE || return 1
diff --git a/test/TEST-11-LVM/test.sh b/test/TEST-11-LVM/test.sh
index cf7d376b..0091148f 100755
--- a/test/TEST-11-LVM/test.sh
+++ b/test/TEST-11-LVM/test.sh
@@ -9,7 +9,7 @@ KVERSION=${KVERSION-$(uname -r)}
 test_run() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=/dev/dracut/root rw rd.auto=1 quiet rd.retry=3 rd.info console=ttyS0,115200n81 selinux=0 rd.debug rd.shell=0 $DEBUGFAIL" \
@@ -72,7 +72,7 @@ test_setup() {
 	-f $TESTDIR/initramfs.makeroot $KVERSION || return 1
     rm -rf -- $TESTDIR/overlay
     # Invoke KVM and/or QEMU to actually create the target filesystem.
-    $testdir/run-qemu -drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -smp 2 -nographic -net none \
+    $testdir/run-qemu -drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/fakeroot rw rootfstype=ext2 quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/root.ext2 || return 1
diff --git a/test/TEST-12-RAID-DEG/test.sh b/test/TEST-12-RAID-DEG/test.sh
index 4c313eb5..269b3a22 100755
--- a/test/TEST-12-RAID-DEG/test.sh
+++ b/test/TEST-12-RAID-DEG/test.sh
@@ -15,7 +15,7 @@ client_run() {
     cp --sparse=always --reflink=auto $TESTDIR/disk3.img $TESTDIR/disk3.img.new
 
     $testdir/run-qemu \
-	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -nographic  -smp 2 \
+	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -nographic  -cpu host -smp 2 \
 	-drive format=raw,index=2,media=disk,file=$TESTDIR/disk2.img.new \
 	-drive format=raw,index=3,media=disk,file=$TESTDIR/disk3.img.new \
 	-net none \
@@ -117,7 +117,7 @@ test_setup() {
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/disk1.img \
 	-drive format=raw,index=2,media=disk,file=$TESTDIR/disk2.img \
 	-drive format=raw,index=3,media=disk,file=$TESTDIR/disk3.img \
-	-m 256M -smp 2 -nographic -net none \
+	-m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/fakeroot rw rootfstype=ext2 quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
 
diff --git a/test/TEST-13-ENC-RAID-LVM/test.sh b/test/TEST-13-ENC-RAID-LVM/test.sh
index b8fd26e2..1dd4179a 100755
--- a/test/TEST-13-ENC-RAID-LVM/test.sh
+++ b/test/TEST-13-ENC-RAID-LVM/test.sh
@@ -17,7 +17,7 @@ test_run() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/check-success.img \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=/dev/dracut/root rw rd.auto rd.retry=20 console=ttyS0,115200n81 selinux=0 rd.debug rootwait $LUKSARGS rd.shell=0 $DEBUGFAIL" \
@@ -31,7 +31,7 @@ test_run() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/check-success.img \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=/dev/dracut/root rw quiet rd.auto rd.retry=20 rd.info console=ttyS0,115200n81 selinux=0 rd.debug  $DEBUGFAIL" \
@@ -45,7 +45,7 @@ test_run() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/check-success.img \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=/dev/dracut/root rw quiet rd.auto rd.retry=10 rd.info console=ttyS0,115200n81 selinux=0 rd.debug  $DEBUGFAIL rd.luks.uuid=failme" \
@@ -111,7 +111,7 @@ test_setup() {
 	-f $TESTDIR/initramfs.makeroot $KVERSION || return 1
     rm -rf -- $TESTDIR/overlay
     # Invoke KVM and/or QEMU to actually create the target filesystem.
-    $testdir/run-qemu -drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -smp 2 -nographic -net none \
+    $testdir/run-qemu -drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/fakeroot rw rootfstype=ext2 quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/root.ext2 || return 1
diff --git a/test/TEST-14-IMSM/test.sh b/test/TEST-14-IMSM/test.sh
index f9f03b7b..d5ce58e0 100755
--- a/test/TEST-14-IMSM/test.sh
+++ b/test/TEST-14-IMSM/test.sh
@@ -13,7 +13,7 @@ client_run() {
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 \
 	-drive format=raw,index=1,media=disk,file=$TESTDIR/disk1 \
 	-drive format=raw,index=2,media=disk,file=$TESTDIR/disk2 \
-	-m 256M -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 $* root=LABEL=root rw debug rd.retry=5 rd.debug console=ttyS0,115200n81 selinux=0 rd.info rd.shell=0 $DEBUGFAIL" \
diff --git a/test/TEST-15-BTRFSRAID/test.sh b/test/TEST-15-BTRFSRAID/test.sh
index adf31b14..d33f5310 100755
--- a/test/TEST-15-BTRFSRAID/test.sh
+++ b/test/TEST-15-BTRFSRAID/test.sh
@@ -9,7 +9,7 @@ test_run() {
     DISKIMAGE=$TESTDIR/TEST-15-BTRFSRAID-root.img
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$DISKIMAGE \
-	-m 256M  -smp 2 -nographic \
+	-m 256M  -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=LABEL=root rw rd.retry=3 rd.info console=ttyS0,115200n81 selinux=0 rd.shell=0 $DEBUGFAIL" \
@@ -78,7 +78,7 @@ test_setup() {
     # Invoke KVM and/or QEMU to actually create the target filesystem.
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$DISKIMAGE \
-	-m 256M  -smp 2 -nographic -net none \
+	-m 256M  -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/fakeroot rw quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
 
diff --git a/test/TEST-16-DMSQUASH/test.sh b/test/TEST-16-DMSQUASH/test.sh
index 876d9103..71f3156d 100755
--- a/test/TEST-16-DMSQUASH/test.sh
+++ b/test/TEST-16-DMSQUASH/test.sh
@@ -19,7 +19,7 @@ test_run() {
         -boot order=d \
         -drive format=raw,bps=1000000,index=0,media=disk,file="$TESTDIR"/livecd.iso \
         -drive format=raw,index=1,media=disk,file="$TESTDIR"/root.img \
-        -m 256M -smp 2 \
+        -m 256M -cpu host -smp 2 \
         -nographic \
         -net none \
         -no-reboot \
@@ -30,7 +30,7 @@ test_run() {
     # "$testdir"/run-qemu \
     #     -drive format=raw,bps=1000000,index=0,media=disk,file="$TESTDIR"/livecd.iso \
     #     -drive format=raw,index=1,media=disk,file="$TESTDIR"/root.img \
-    #     -m 256M -smp 2 \
+    #     -m 256M -cpu host -smp 2 \
     #     -net none \
     #     -append "root=live:CDLABEL=LiveCD live quiet rhgb selinux=0 rd.live.check" \
     #     -initrd "$TESTDIR"/initramfs.testing
diff --git a/test/TEST-17-LVM-THIN/test.sh b/test/TEST-17-LVM-THIN/test.sh
index 1ad9ba6b..c375fa2d 100755
--- a/test/TEST-17-LVM-THIN/test.sh
+++ b/test/TEST-17-LVM-THIN/test.sh
@@ -9,7 +9,7 @@ KVERSION=${KVERSION-$(uname -r)}
 test_run() {
     $testdir/run-qemu \
 	-drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 \
-	-m 256M -smp 2 -nographic \
+	-m 256M -cpu host -smp 2 -nographic \
 	-net none \
         -no-reboot \
 	-append "panic=1 root=/dev/dracut/root rw rd.auto=1 quiet rd.retry=3 rd.info console=ttyS0,115200n81 selinux=0 rd.debug rd.shell=0 $DEBUGFAIL" \
@@ -72,7 +72,7 @@ test_setup() {
 	-f $TESTDIR/initramfs.makeroot $KVERSION || return 1
     rm -rf -- $TESTDIR/overlay
     # Invoke KVM and/or QEMU to actually create the target filesystem.
-    $testdir/run-qemu -drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -smp 2 -nographic -net none \
+    $testdir/run-qemu -drive format=raw,index=0,media=disk,file=$TESTDIR/root.ext2 -m 256M -cpu host -smp 2 -nographic -net none \
 	-append "root=/dev/fakeroot rw rootfstype=ext2 quiet console=ttyS0,115200n81 selinux=0" \
 	-initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/root.ext2 || return 1
diff --git a/test/TEST-20-NFS/test.sh b/test/TEST-20-NFS/test.sh
index 039fb61b..66e5e3e1 100755
--- a/test/TEST-20-NFS/test.sh
+++ b/test/TEST-20-NFS/test.sh
@@ -14,7 +14,7 @@ run_server() {
     fsck -a $TESTDIR/server.ext3 || return 1
     $testdir/run-qemu \
         -drive format=raw,index=0,media=disk,file=$TESTDIR/server.ext3 \
-        -m 256M -smp 2 \
+        -m 256M -cpu host -smp 2 \
         -display none \
         -net socket,listen=127.0.0.1:12320 \
         -net nic,macaddr=52:54:00:12:34:56,model=e1000 \
@@ -51,7 +51,7 @@ client_test() {
 
     $testdir/run-qemu \
         -drive format=raw,index=0,media=disk,file=$TESTDIR/client.img \
-        -m 256M -smp 2 -nographic \
+        -m 256M -cpu host -smp 2 -nographic \
         -net nic,macaddr=$mac,model=e1000 \
         -net socket,connect=127.0.0.1:12320 \
         -watchdog i6300esb -watchdog-action poweroff \
diff --git a/test/TEST-30-ISCSI/test.sh b/test/TEST-30-ISCSI/test.sh
index 53ac5c79..1abde7a4 100755
--- a/test/TEST-30-ISCSI/test.sh
+++ b/test/TEST-30-ISCSI/test.sh
@@ -19,7 +19,7 @@ run_server() {
         -drive format=raw,index=1,media=disk,file=$TESTDIR/root.ext3 \
         -drive format=raw,index=2,media=disk,file=$TESTDIR/iscsidisk2.img \
         -drive format=raw,index=3,media=disk,file=$TESTDIR/iscsidisk3.img \
-        -m 512M  -smp 2 \
+        -m 512M  -cpu host -smp 2 \
         -display none \
         -serial $SERIAL \
         -net nic,macaddr=52:54:00:12:34:56,model=e1000 \
@@ -46,7 +46,7 @@ run_client() {
 
     $testdir/run-qemu \
         -drive format=raw,index=0,media=disk,file=$TESTDIR/client.img \
-        -m 512M -smp 2 -nographic \
+        -m 512M -cpu host -smp 2 -nographic \
         -net nic,macaddr=52:54:00:12:34:00,model=e1000 \
         -net nic,macaddr=52:54:00:12:34:01,model=e1000 \
         -net socket,connect=127.0.0.1:12330 \
@@ -207,7 +207,7 @@ test_setup() {
         -drive format=raw,index=1,media=disk,file=$TESTDIR/client.img \
         -drive format=raw,index=2,media=disk,file=$TESTDIR/iscsidisk2.img \
         -drive format=raw,index=3,media=disk,file=$TESTDIR/iscsidisk3.img \
-        -smp 2 -m 256M -nographic -net none \
+        -cpu host -smp 2 -m 256M -nographic -net none \
         -append "root=/dev/fakeroot rw rootfstype=ext3 quiet console=ttyS0,115200n81 selinux=0" \
         -initrd $TESTDIR/initramfs.makeroot  || return 1
     grep -F -m 1 -q dracut-root-block-created $TESTDIR/client.img || return 1
diff --git a/test/TEST-40-NBD/test.sh b/test/TEST-40-NBD/test.sh
index 8d49b057..7f7aa661 100755
--- a/test/TEST-40-NBD/test.sh
+++ b/test/TEST-40-NBD/test.sh
@@ -17,7 +17,7 @@ run_server() {
         -drive format=raw,index=0,media=disk,file=$TESTDIR/server.ext2 \
         -drive format=raw,index=1,media=disk,file=$TESTDIR/nbd.ext2 \
         -drive format=raw,index=2,media=disk,file=$TESTDIR/encrypted.ext2 \
-        -m 256M -smp 2 \
+        -m 256M -cpu host -smp 2 \
         -display none \
         -net nic,macaddr=52:54:00:12:34:56,model=e1000 \
         -net socket,listen=127.0.0.1:12340 \
@@ -55,7 +55,7 @@ client_test() {
 
     $testdir/run-qemu \
         -drive format=raw,index=0,media=disk,file=$TESTDIR/flag.img \
-        -m 512M -smp 2 \
+        -m 512M -cpu host -smp 2 \
         -nographic \
         -net nic,macaddr=$mac,model=e1000 \
         -net socket,connect=127.0.0.1:12340 \
@@ -249,7 +249,7 @@ make_encrypted_root() {
     $testdir/run-qemu \
         -drive format=raw,index=0,media=disk,file=$TESTDIR/flag.img \
         -drive format=raw,index=1,media=disk,file=$TESTDIR/encrypted.ext2 \
-        -m 256M -smp 2\
+        -m 256M -cpu host -smp 2\
         -nographic -net none \
         -append "root=/dev/fakeroot rw quiet console=ttyS0,115200n81 selinux=0" \
         -initrd $TESTDIR/initramfs.makeroot  || return 1
diff --git a/test/TEST-50-MULTINIC/test.sh b/test/TEST-50-MULTINIC/test.sh
index ef27682b..e919bace 100755
--- a/test/TEST-50-MULTINIC/test.sh
+++ b/test/TEST-50-MULTINIC/test.sh
@@ -14,7 +14,7 @@ run_server() {
     fsck -a "$TESTDIR"/server.ext3 || return 1
     $testdir/run-qemu \
         -drive format=raw,index=0,media=disk,file="$TESTDIR"/server.ext3 \
-        -m 512M -smp 2 \
+        -m 512M -cpu host -smp 2 \
         -display none \
         -net socket,listen=127.0.0.1:12350 \
         -net nic,macaddr=52:54:01:12:34:56,model=e1000 \
@@ -49,7 +49,7 @@ client_test() {
         return 1
     fi
 
-    $testdir/run-qemu -drive format=raw,index=0,media=disk,file="$TESTDIR"/client.img -m 512M -smp 2 -nographic \
+    $testdir/run-qemu -drive format=raw,index=0,media=disk,file="$TESTDIR"/client.img -m 512M -cpu host -smp 2 -nographic \
         -net socket,connect=127.0.0.1:12350 \
         -net nic,macaddr=52:54:00:12:34:$mac1,model=e1000 \
         -net nic,macaddr=52:54:00:12:34:$mac2,model=e1000 \